//--- OBJECT WRITE BEGIN ---
if(isObject(FairyGui))
   FairyGui.delete();
new GuiControl(FairyGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 2";
   enabled = "1";
   visible = "1";
   clipToParent = "1";

   new GuiWindowCtrl() {
      profile = "GuiWindowProfile";
      horizSizing = "right";
      vertSizing = "bottom";
      position = "136 98";
      extent = "300 300";
      minExtent = "8 2";
      enabled = "1";
      visible = "1";
      clipToParent = "1";
      command = "canvas.popdialog(\"FairyGUI\");";
      accelerator = "escape";
      text = "Fairies";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
      closeCommand = "canvas.popdialog(\"FairyGUI\");";

      new GuiBitmapButtonCtrl() {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 30";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         text = "New Fairy";
         command = "commandToServer('newFairy');";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "100 255 100 255";
      };
      new GuiBitmapButtonCtrl(FairyButton_0) {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 170";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         command = "commandToServer('clearFairies');";
         clipToParent = "1";
         text = "Clear All Fairies";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "255 100 100 255";
      };
      new GuiBitmapButtonCtrl() {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 110";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         command = "commandToServer('toggleFairy');";
         text = "Toggle Fairy";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "155 155 255 255";
      };
      new GuiBitmapButtonCtrl() {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 70";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         command = "commandToServer('killFairy');";
         clipToParent = "1";
         text = "Remove Fairy";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "255 100 100 255";
      };
      new GuiBitmapButtonCtrl(FairyButton_1) {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 210";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         command = "commandToServer('updateSpawn');";
         clipToParent = "1";
         text = "Toggle Spawning";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "255 255 100 255";
      };
      new GuiBitmapButtonCtrl(FairyButton_2) {
         profile = "BlockButtonProfile";
         horizSizing = "left";
         vertSizing = "bottom";
         position = "171 250";
         extent = "121 38";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         command = "commandToServer('updateForcedSpawn');";
         text = "Force Spawning";
         groupNum = "-1";
         buttonType = "PushButton";
         bitmap = "base/client/ui/button1";
         lockAspectRatio = "0";
         alignLeft = "0";
         alignTop = "0";
         overflowImage = "0";
         mKeepCached = "0";
         mColor = "255 255 100 255";
      };
      new GuiScrollCtrl() {
         profile = "GuiScrollProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "9 34";
         extent = "158 251";
         minExtent = "8 2";
         enabled = "1";
         visible = "1";
         clipToParent = "1";
         willFirstRespond = "0";
         hScrollBar = "alwaysOff";
         vScrollBar = "dynamic";
         constantThumbHeight = "0";
         childMargin = "0 0";
         rowHeight = "40";
         columnWidth = "30";

         new GuiTextListCtrl(Fairy_List) {
            profile = "GuiTextListProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "1 1";
            extent = "156 2";
            altCommand = "selectFairy();";
            minExtent = "8 2";
            enabled = "1";
            visible = "1";
            clipToParent = "1";
            enumerate = "0";
            resizeCell = "1";
            columns = "0";
            fitParentWidth = "1";
            clipColumnText = "0";
         };
      };
   };
};
//--- OBJECT WRITE END ---
if (!$FairyBind)
{
   $remapDivision[$remapCount] = "Fairy";
   $remapName[$remapCount] = "Toggle GUI";
   $remapCmd[$remapCount] = "FairyGUI";
   $remapCount++;
   $FairyBind=1;
}
function FairyGUI(%a)
{
   if(!%a)
      return;
   if(FairyGui.isAwake())
      canvas.popdialog("FairyGui");
   else
      canvas.pushdialog("FairyGui");
}
function selectFairy()
{
   commandToServer('ChangeFairy',Fairy_List.data[Fairy_List.getSelectedID()]);
}
function FairyGui::onWake(%this)
{ 
   FairyButton_0.setVisible($IamAdmin);
   FairyButton_1.setVisible($IamAdmin);
   FairyButton_2.setVisible($IamAdmin);
   if(isObject(ServerConnection))
      if(Fairy_List.lastServer != nameToID("serverConnection"))
      {
         Fairy_List.lastServer = nameToID("serverConnection");
         Fairy_List.clear();
         Fairy_List.rows=-1;
         %c=getDataBlockGroupSize();
         for(%i=0;%i<%c;%i++)
         {
            %d = getDataBlock(%i);
            %l = %d.getClassName();
            
            if(%d.uiName !$= "")
               if(%l $= "fxLightData")
               {
                  Fairy_List.addRow(Fairy_List.rows++,%d.uiname);
                  Fairy_List.data[Fairy_List.rows]=%d;
               }
            
         }
      }
}
